leetcode题解-287. Find the Duplicate Number

题目:

Given an array nums containing n + 1 integers where each integer is between 1 and n (inclusive), prove that at least one duplicate number must exist. Assume that there is only one duplicate number, find the duplicate one.

Note:
You must not modify the array (assume the array is read only).
You must use only constant, O(1) extra space.
Your runtime complexity should be less than O(n2).
There is only one duplicate number in the array, but it could be repeated more than once.

题目是要发现1~n中的一个重复数字,不过有较多的条件限制,不能修改数组,O(1)的空间复杂度,所以我们第一种简单的思路就是,暴力法,直接两个嵌套循环即可:

    public int findDuplicate(int[] nums) {
        for(int i=0; i<nums.length; i++){
            for(int j=i+1; j<nums.length; j++){
                if(nums[i] == nums[j])
                    return nums[i];
            }
        }
        return 0;
    }

这种方法效率极低,以为题目中说了只有一个重复的数字,可能会重复多次出现,所以我们可以尝试使用“二分法”。二分的是1~n,然后对数组进行计数,如果大于mid的过半,则说明在上半区,否则下半区。一直二分下去即可,代码入下:

    public static int findDuplicate1(int[] nums) {
        int low=1, high=nums.length-1, mid;
        while(low < high){
            mid = low + (low+high)/2;
            int count = 0;
            for(int i=0; i<nums.length; i++){
                if(nums[i] <= mid)
                    count++;
            }
            if(count > mid)
                high = mid;
            else
                low = mid + 1;
        }
        return low;
    }
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值